//
//  ViewController.m
//  添加图片
//
//  Created by 帅 on 16/4/14.
//  Copyright © 2016年 xinlin. All rights reserved.
//

#import "ViewController.h"

#import "ZYQAssetPickerController.h"
#import "BrowseImagesViewController.h"

// 数据配置
#define LINE_COUNT 4
#define SPACING 10 * PROPORTION

@interface ViewController ()<UINavigationControllerDelegate,UIImagePickerControllerDelegate,ZYQAssetPickerControllerDelegate,UIAlertViewDelegate>
{
    NSMutableArray *array;
    UIButton *buttons;
}

@property (strong, nonatomic) UIView *contentView;
@property (strong, nonatomic) UIButton *addButton;
@property (assign, nonatomic) CGFloat imageWidth;
@property (strong, nonatomic) NSMutableArray *selectImages;
@property (strong, nonatomic) NSMutableArray *selectButtons;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    _selectButtons = [[NSMutableArray alloc] init];
    _selectImages = [[NSMutableArray alloc] init];
    
    [self loadUI];
}

- (void)loadUI{
    _imageWidth = (SCREEN_WIDTH - ((LINE_COUNT + 1) * SPACING)) / LINE_COUNT;
    _contentView = [[UIView alloc] initWithFrame:CGRectMake(0, 100 * PROPORTION, SCREEN_WIDTH, _imageWidth + 2 * SPACING)];
    _contentView.clipsToBounds = YES;
    [self.view addSubview:_contentView];
    
    _addButton = [UIButton buttonWithType:UIButtonTypeSystem];
    _addButton.frame = CGRectMake(SPACING, SPACING, _imageWidth, _imageWidth);
    [_addButton setTitle:@"添加" forState:UIControlStateNormal];
    _addButton.layer.borderWidth = 1;
    _addButton.layer.borderColor = [UIColor orangeColor].CGColor;
    [_addButton addTarget:self action:@selector(addButtonPressed:) forControlEvents:UIControlEventTouchUpInside];
    [_contentView addSubview:_addButton];
    
    
    //  修改
    for (int i=0; i<array.count; i++) {
        buttons = [[UIButton alloc] initWithFrame:CGRectMake(SPACING, SPACING, _imageWidth, _imageWidth)];
        [buttons setImage:[array objectAtIndex:i] forState:UIControlStateNormal];
        [buttons addTarget:self action:@selector(imageButtonPressed:) forControlEvents:UIControlEventTouchUpInside];
        [_contentView addSubview:buttons];
        [_selectImages addObject:array[i]];
        [_selectButtons addObject:buttons];
        //
    }
}

- (void)addButtonPressed:(UIButton *)btn{
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:nil message:nil preferredStyle:UIAlertControllerStyleActionSheet];
    
    UIAlertAction *action1 = [UIAlertAction actionWithTitle:@"拍照" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        [self selectFromCamera];
    }];
    
    UIAlertAction *action2 = [UIAlertAction actionWithTitle:@"从相册中选择" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        [self selectFromPhoto];
    }];
    
    UIAlertAction *action3 = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
        
    }];
    
    [alert addAction:action1];
    [alert addAction:action2];
    [alert addAction:action3];
    
    [self presentViewController:alert animated:YES completion:nil];
}

- (void)selectFromCamera
{
    UIImagePickerController *pickerImage = [[UIImagePickerController alloc] init];
    if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
        pickerImage.sourceType = UIImagePickerControllerSourceTypeCamera;
        pickerImage.mediaTypes = [UIImagePickerController availableMediaTypesForSourceType:pickerImage.sourceType];
    }
    pickerImage.delegate = self;
    pickerImage.allowsEditing = NO;
    [self presentViewController:pickerImage animated:YES completion:nil];
    
}

- (void)selectFromPhoto
{
    ZYQAssetPickerController *picker = [[ZYQAssetPickerController alloc] init];
    picker.maximumNumberOfSelection = 4-_selectImages.count;//限制张数，最多四张
    picker.assetsFilter = [ALAssetsFilter allPhotos];
    picker.showEmptyGroups = NO;
    picker.delegate = self;
    picker.selectionFilter = [NSPredicate predicateWithBlock:^BOOL(id evaluatedObject, NSDictionary *bindings) {
        if ([[(ALAsset*)evaluatedObject valueForProperty:ALAssetPropertyType] isEqual:ALAssetTypeVideo]) {
            NSTimeInterval duration = [[(ALAsset*)evaluatedObject valueForProperty:ALAssetPropertyDuration] doubleValue];
            return duration >= 5;
        } else {
            return YES;
        }
    }];
    
    [self presentViewController:picker animated:YES completion:NULL];
}

//加载图片
-(void)assetPickerController:(ZYQAssetPickerController *)picker didFinishPickingAssets:(NSMutableArray *)assets {
    for (int i = 0; i < assets.count; i ++) {
        
        ALAsset *asset = assets[i];
        UIImage *image = [UIImage imageWithCGImage:asset.thumbnail];
        
        
        buttons = [[UIButton alloc] initWithFrame:CGRectMake(SPACING, SPACING, _imageWidth, _imageWidth)];
        [buttons setImage:image forState:UIControlStateNormal];
        [buttons addTarget:self action:@selector(imageButtonPressed:) forControlEvents:UIControlEventTouchUpInside];
        //  添加图片
        [_contentView addSubview:buttons];
        //[_selectImages addObject:i]
        [_selectImages addObject:image];
        [_selectButtons addObject:buttons];
        
    }
    
    [self updateUserInterface];
}
//  跳转
- (void)imageButtonPressed:(UIButton *)sender {
    //新建 个对象  不同的地址了
    NSMutableArray *temp = [NSMutableArray arrayWithArray:_selectImages];
    //多是强指针  指向同一地址  看着  这是原来的样子
    BrowseImagesViewController *vc = [[BrowseImagesViewController alloc] initWithIndex:[_selectButtons indexOfObject:sender] selectImages:temp];
    __weak ViewController *weakSelf = self;
    vc.deleteBlock = ^(NSInteger index) {
        UIButton *button = [weakSelf.selectButtons objectAtIndex:index];
        [button removeFromSuperview];
        [weakSelf.selectImages removeObjectAtIndex:index];
        //这个得有
        [_selectButtons removeObjectAtIndex:index];
        [weakSelf updateUserInterface];
        NSLog(@"B:%ld ---I%ld",_selectButtons.count,_selectImages.count);
        
    };
    [self.navigationController pushViewController:vc animated:YES];
}
//  刷新
- (void)updateUserInterface {
    //aaaa
    if (_selectButtons.count>=4) {
        _addButton.hidden = YES;
    }else{
        _addButton.hidden = NO;
    }
    
    [self resetAllImagePosition];
    
    _addButton.frame = [self frameWithButtonIndex:_selectButtons.count];
    _contentView.frame = CGRectMake(_contentView.frame.origin.x, _contentView.frame.origin.y, SCREEN_WIDTH, _addButton.bounds.size.height + _addButton.frame.origin.y + SPACING);
}

- (void)resetAllImagePosition {
    
    NSInteger count = _selectButtons.count;
    
    for (int i = 0; i < count; i ++) {
        
        UIButton *button = _selectButtons[i];
        button.frame = [self frameWithButtonIndex:i];
    }
}

- (CGRect)frameWithButtonIndex:(NSInteger)index {
    
    index ++;
    
    NSInteger row = ceil(index * 1.0 / LINE_COUNT); // 第几行
    NSInteger cloumn = index % LINE_COUNT; // 第几列
    
    if (cloumn == 0) {
        
        cloumn += LINE_COUNT;
    }
    
    return CGRectMake(SPACING * cloumn + _imageWidth * (cloumn - 1), SPACING * row + _imageWidth * (row - 1), _imageWidth, _imageWidth);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
